Debian Bug report logs - #572529
php-apc: APC 3.0.19 contains a race condition which is (supposedly) fixed in 3.1.x

version graph

Package: php-apc; Maintainer for php-apc is Pietro Monteiro <pietro@riseup.net>; Source for php-apc is src:php-apcu.

Reported by: Shane Allen <sallen@hrsmart.com>

Date: Thu, 4 Mar 2010 18:18:02 UTC

Severity: important

Found in version php-apc/3.0.19-2

Fixed in version php-apc/3.1.3p1-2

Done: Pietro Ferrari <pietro@riseup.net>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Pietro Ferrari <pietro@riseup.net>:
Bug#572529; Package php-apc. (Thu, 04 Mar 2010 18:18:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Shane Allen <sallen@hrsmart.com>:
New Bug report received and forwarded. Copy sent to Pietro Ferrari <pietro@riseup.net>. (Thu, 04 Mar 2010 18:18:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Shane Allen <sallen@hrsmart.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: php-apc: APC 3.0.19 contains a race condition which is (supposedly) fixed in 3.1.x
Date: Thu, 04 Mar 2010 11:40:13 -0600
Package: php-apc
Version: 3.0.19-2
Severity: important

I've got a server which is randomly becoming unstable after a period of time. After a lot of troubleshooting, I believe I've narrowed it down to APC. The symptoms I encounter are Apache having a large number of threads in the gracefully finishing state (G) for a very long time (SS = 60k+). I finally looked in top and discovered the threads are sticking in futex_wait. After some further searching, I found the following resources:

http://nirlevy.blogspot.com/2009/06/apc-futexwait-lockdown-make-your-apache.html
http://t3.dotgnu.info/blog/php/user-cache-timebomb.html
http://pecl.php.net/bugs/bug.php?id=15179 (this indicates that the problem is resolved)

The specific issue we have is that when TTLs are enabled, the memory fragmentation causes allocate and deallocate calls to become more and more costly, and you end up in a downward spiral until the system becomes unusable. If you disable TTLs in my environment then you end up with 'class could not be found' errors when APC performs mass memory cleanups which occur when memory fills up.

I will be installing the latest 3.1 package on our dev server and testing it now and I believe it would be in everyone's best interests to get the latest release into unstable, at least. I will update this ticket if my testing reveals that the problem is in fact mitigated by 3.1.x.

-- System Information:
Debian Release: 5.0.4
  APT prefers stable
  APT policy: (500, 'stable')
Architecture: i386 (x86_64)

Kernel: Linux 2.6.26-2-amd64 (SMP w/16 CPU cores)
Locale: LANG=en_US, LC_CTYPE=en_US (charmap=ISO-8859-1)
Shell: /bin/sh linked to /bin/bash

Versions of packages php-apc depends on:
ii  libapache2-mod-php 5.2.6.dfsg.1-1+lenny6 server-side, HTML-embedded scripti
ii  libc6              2.7-18lenny2          GNU C Library: Shared libraries
ii  php5-cli [phpapi-2 5.2.6.dfsg.1-1+lenny6 command-line interpreter for the p

php-apc recommends no packages.

Versions of packages php-apc suggests:
ii  php5-gd            5.2.6.dfsg.1-1+lenny6 GD module for php5

-- no debconf information




Reply sent to Pietro Ferrari <pietro@riseup.net>:
You have taken responsibility. (Sat, 03 Apr 2010 18:36:14 GMT) Full text and rfc822 format available.

Notification sent to Shane Allen <sallen@hrsmart.com>:
Bug acknowledged by developer. (Sat, 03 Apr 2010 18:36:15 GMT) Full text and rfc822 format available.

Message #10 received at 572529-close@bugs.debian.org (full text, mbox):

From: Pietro Ferrari <pietro@riseup.net>
To: 572529-close@bugs.debian.org
Subject: Bug#572529: fixed in php-apc 3.1.3p1-2
Date: Sat, 03 Apr 2010 18:33:06 +0000
Source: php-apc
Source-Version: 3.1.3p1-2

We believe that the bug you reported is fixed in the latest version of
php-apc, which is due to be installed in the Debian FTP archive:

php-apc_3.1.3p1-2.debian.tar.gz
  to main/p/php-apc/php-apc_3.1.3p1-2.debian.tar.gz
php-apc_3.1.3p1-2.dsc
  to main/p/php-apc/php-apc_3.1.3p1-2.dsc
php-apc_3.1.3p1-2_i386.deb
  to main/p/php-apc/php-apc_3.1.3p1-2_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 572529@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Pietro Ferrari <pietro@riseup.net> (supplier of updated php-apc package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA512

Format: 1.8
Date: Sat, 27 Mar 2010 16:55:11 -0700
Source: php-apc
Binary: php-apc
Architecture: source i386
Version: 3.1.3p1-2
Distribution: unstable
Urgency: low
Maintainer: Pietro Ferrari <pietro@riseup.net>
Changed-By: Pietro Ferrari <pietro@riseup.net>
Description: 
 php-apc    - APC (Alternative PHP Cache) module for PHP 5
Closes: 536843 571661 572205 572525 572529
Changes: 
 php-apc (3.1.3p1-2) unstable; urgency=low
 .
   * Upload package to unstable
      (Closes: #572525 - "completely unusable with php 5.3",
       Closes: #571661 - "Version in sid uninstallable...",
       Closes: #572205 - "unstable with php-5.3",
       Closes: #572529 - "APC 3.0.19 contains a race condition..." and
       Closes: #536843 - "Newer version 3.1.2 is available")
 .
 php-apc (3.1.3p1-1) experimental; urgency=low
 .
   * New upstream release.
   * Switch to dpkg-source 3.0 (quilt) format.
   * Drop patches needed to build 3.0.19-3.
Checksums-Sha1: 
 2c55bc9c2383049bad91bbc34c6daeaa6e1b1311 1696 php-apc_3.1.3p1-2.dsc
 e0ad55c78736d8af60d23a6e79abeb057b5e4073 4421 php-apc_3.1.3p1-2.debian.tar.gz
 2c6066411188375a3882b1d159aa00025695c8b2 77810 php-apc_3.1.3p1-2_i386.deb
Checksums-Sha256: 
 4408e5805e7bd80167066890abf785341449a208df66ebf1d2250b9b19f1a1a5 1696 php-apc_3.1.3p1-2.dsc
 fd9740c8a6fe04886592b68006a312d61cd9764c034e4c9d0064d4a5ef7be81e 4421 php-apc_3.1.3p1-2.debian.tar.gz
 26e3e1bf592186a467edd5eee5b66145b6112db0d496c96f6c3f12062c81c832 77810 php-apc_3.1.3p1-2_i386.deb
Files: 
 22491af9a724b58e90616b53f0512422 1696 web optional php-apc_3.1.3p1-2.dsc
 990aa0acc274314dc86101a30d743599 4421 web optional php-apc_3.1.3p1-2.debian.tar.gz
 7c342e7fe62b04b0e5b8fc9cc69b38a4 77810 web optional php-apc_3.1.3p1-2_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iQIcBAEBCgAGBQJLss+MAAoJEIy/mjIoYaeQDHwP/i3ApEh0r7mOWxjX+Be/blBp
EFskL/BHtY75T1o7kP6llypdkJPy3SwXwLGivW+7SS2MAwgLzruK7tz6AA8qiy2G
ICy35jTMeV1B4jiYu849BPD3nF1Zm4MwbBPsXHikqgNVC40hwlESOB/i+KUn27mP
dd6Sz1ZKz4hZY1jOslw3vmoJVIGTNAn9MOHwIicdl3tQbB+TR7ebrnHWQtpDuJYx
EHcibywfT8IGIWd2XE23LCQTRBarP6LPKm8LchXHdMTIUCrJB4nhIJCrEmZpI3n9
cDBVyVdiLolYFQV/S6IcfNQAzTTwQG+VMyMBL0ulYtX8gN1Fw9L+9nYO2M9p4mFQ
UhKDDrlJFjBt0cWsONx6hCMBuetq1eNO/+sajyOHRJglzwh7Z3F+K51zQqIPJZSL
GvIV4XnHgIHy/9SNx14zGQ8PhGt8DSftDvHr5Yq6Tbsxpk7cJ5fAJmvAGhvg3m/f
q/Gs+edZMEoDFc2Rydlvr17Mz3MaxOo2hpmm+aKtW1fjOWBVX/iXvY7ycsxowEar
IivW02PrW35jrEpOnzHs+3D8WpHUTzKXB6AUapgD800YSy7jeAScFijkpAFk7HuD
RY2QagHp30gmXRU8Bj/H1i8rrW03PUBbMnmSxbomiYEvnhQEGgE1H3QndhAwphBF
7Kp55ZnIWZ4ypXvMsha1
=aYdZ
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 12 May 2010 07:36:28 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 14:17:31 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.